﻿using Connected.Net;

namespace Connected.Net.Hubs
{
	public interface IServer<TArgs>
	{
		event EventHandler<TArgs>? Received;
		ClientMessages<TArgs> Messages { get; }
		Clients<TArgs> Clients { get; }

		Task Send(TArgs args);
		Task Receive(TArgs args);
		Task Acknowledge(string connection, IMessageAcknowledgeArgs args);
	}
}
